%define nx_name nx_lsa
%define nx_version 4.0.225
%define nx_release 1

Summary: Driver for NetXen TNIC.
Name: %{nx_name}
Version: %{nx_version}
Release: %{nx_release}
Source: %{name}-%{version}.tar.gz
Vendor: NetXen, Inc.
License: GPL
Group: System Environment/Kernel
Provides: %{name}
URL: http://www.netxen.com
Requires: kernel, bash, nx_nic
Buildroot: %{_tmppath}/%{name}-%{version}/bldroot

%if "%{?KVER}" != ""
%define kernel %{KVER}
%endif
%if "%{?kernel}" == ""
%define kernel %(uname -r)
%endif

%define files_list %{_builddir}/%{name}-%{version}/files.list
%define netxen_rules /etc/udev/rules.d/99-netxen.rules

%define debug_package %{nil}

%description
This package contains the driver and tools for NetXen's TNIC cards.

%prep
%setup -q

%build
make KERNEL_VERSION=%{kernel} RPM_BUILD=1

%install
if [ -d /lib/modules/%{kernel}/updates ]; then
    DIR_LIST=/lib/modules/%{kernel}/updates/drivers/net
else
    DIR_LIST=/lib/modules/%{kernel}/kernel/drivers/net
fi
DIR_LIST="$DIR_LIST /usr/bin /usr/local/bin"
DIR_LIST="$DIR_LIST /usr/local/man/man4 /usr/man/man4 /usr/share/man/man4"
rm -rf $RPM_BUILD_ROOT
for dir in $DIR_LIST; do
    mkdir -p $RPM_BUILD_ROOT$dir
done
make PREFIX=$RPM_BUILD_ROOT KERNEL_VERSION=%{kernel} install
if [ -d /lib/modules/%{kernel}/updates ]; then
    mv $RPM_BUILD_ROOT/lib/modules/%{kernel}/updates/*.ko \
       $RPM_BUILD_ROOT/lib/modules/%{kernel}/updates/drivers/net
fi
find $RPM_BUILD_ROOT -type f -print | \
    sed -e "s#^$RPM_BUILD_ROOT##" -e "/^\/usr.*\/man\//s/\(.*\)/%doc \1/" \
    > %{files_list}

%files -f %{files_list}
%defattr(-,root,root)

%clean
rm -rf $RPM_BUILD_ROOT

%pre
rm -f %{netxen_rules}

%post
depmod -v %{kernel} >/dev/null

%postun
depmod -v %{kernel} >/dev/null
