%define nx_name nx_nic
%define nx_version 4.0.230
%define nx_release 1

Summary: NetXen driver for NIC.
Name: %{nx_name}
Version: %{nx_version}
Release: %{nx_release}
Source: %{name}-%{version}.tar.gz
Vendor: NetXen, Inc.
License: GPL
Group: System Environment/Kernel
Provides: %{name}
URL: http://www.netxen.com
Requires: kernel, bash
Buildroot: %{_tmppath}/%{name}-%{version}/bldroot

%if "%{?KVER}" != ""
%define kernel %{KVER}
%endif
%if "%{?kernel}" == ""
%define kernel %(uname -r)
%endif

%define files_list %{_builddir}/%{name}-%{version}/files.list
%define exec_script /usr/bin/nx_snmp.pl
%define netxen_driver /lib/modules/%{kernel}/kernel/drivers/net/netxen/netxen_nic.ko
%define snmpd_conf /etc/snmp/snmpd.conf
%define mid_obj_id .1.3.6.1.2.1.10.7.11.1
%define pass_entry %(echo "pass %{mid_obj_id} %{exec_script}")

# If a blacklist file exists put an entry in it otherwise put it in a modprobe file.
%define bl_files %(echo "/etc/modprobe.d/blacklist /etc/hotplug/blacklist %{bl_files2}")
%define bl_files2 %(echo "/etc/modprobe.conf.local /etc/modprobe.conf /etc/modules.conf")
%define blacklist_file %(for f in %{bl_files}; do [ -f $f ] && echo $f && break; done)
%if "%{blacklist_file}" != "/etc/hotplug/blacklist"
%define blacklist_entry %(echo "blacklist netxen_nic")
%else
%define blacklist_entry netxen_nic
%endif

%define debug_package %{nil}

%description
This package contains the Linux driver for the NetXen's NIC.

%prep
%setup -q

%build
make KERNEL_VERSION=%{kernel} RPM_BUILD=1

%install
if [ -d /lib/modules/%{kernel}/updates ]; then
    DIR_LIST=/lib/modules/%{kernel}/updates/drivers/net
else
    DIR_LIST=/lib/modules/%{kernel}/kernel/drivers/net
fi
DIR_LIST="$DIR_LIST /usr/bin /usr/local/bin"
DIR_LIST="$DIR_LIST /lib/firmware/%{kernel} /usr/lib/hotplug/firmware"
DIR_LIST="$DIR_LIST /usr/local/man/man4 /usr/man/man4 /usr/share/man/man4"
EXEC_SCRIPT=$RPM_BUILD_ROOT%{exec_script}
rm -rf $RPM_BUILD_ROOT
for dir in $DIR_LIST; do
    mkdir -p $RPM_BUILD_ROOT$dir
done
cp -f $(basename $EXEC_SCRIPT) $EXEC_SCRIPT
make PREFIX=$RPM_BUILD_ROOT KERNEL_VERSION=%{kernel} install
if [ -d /lib/modules/%{kernel}/updates ]; then
    mv $RPM_BUILD_ROOT/lib/modules/%{kernel}/updates/*.ko \
       $RPM_BUILD_ROOT/lib/modules/%{kernel}/updates/drivers/net
fi
find $RPM_BUILD_ROOT -type f -print | \
    sed -e "s#^$RPM_BUILD_ROOT##" -e "/^\/usr.*\/man\//s/\(.*\)/%doc \1/" \
    > %{files_list}

%files -f %{files_list}
%defattr(-,root,root)

%clean
rm -rf $RPM_BUILD_ROOT

%post
# If the GPL Nic driver exists on this machine then blacklist it.
if [ -f %{netxen_driver} ]; then
    if ! grep -q "%{blacklist_entry}" %{blacklist_file}; then
        cp %{blacklist_file} %{blacklist_file}.saved
        echo "%{blacklist_entry}" >> %{blacklist_file}
    fi
fi
depmod -v %{kernel} >/dev/null
if [ -f %{snmpd_conf} ]; then
    if ! grep -q "%{pass_entry}" %{snmpd_conf}; then
        cp %{snmpd_conf} %{snmpd_conf}.saved
        echo "%{pass_entry}" >> %{snmpd_conf}
    fi
fi

%postun
# If the GPL Nic driver was blacklisted then remove that blacklisting.
if [ -f %{netxen_driver} ]; then
    grep -v "%{blacklist_entry}" %{blacklist_file} > %{blacklist_file}.tmp$$
    mv %{blacklist_file}.tmp$$ %{blacklist_file}
fi
depmod -v %{kernel} >/dev/null
if [ -f %{snmpd_conf} ]; then
    grep -v "%{pass_entry}" %{snmpd_conf} > %{snmpd_conf}.tmp$$
    mv %{snmpd_conf}.tmp$$ %{snmpd_conf}
fi
